<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <link rel="stylesheet" href="styles.css" />
    <script src="script.js" defer></script>
    <title>Document</title>
  </head>
  <body>
    <table id="tableValue">
      <script>
        for (var i = 0; i < 100; i++) {
          document.write('<tr>');
          for (var y = 0; y < 100; y++) {
            if (y === 0 && i === 0) {
              document.write("<th class='fill' draggable='true'>" + i + '</th>');
            } else {
              document.write("<td class='empty' >" + i + '</td>');
            }
          }
          document.write('</tr>');
        }
      </script>
    </table>

    <script>
      const fill = document.querySelector('.fill');
      const empties = document.querySelectorAll('.empty');
      const startTime = performance.now();
      // Fill listeners
      fill.addEventListener('dragstart', dragStart);
      fill.addEventListener('dragend', dragEnd);

      // Loop through empty boxes and add listeners
      for (const empty of empties) {
        empty.addEventListener('dragover', dragOver);
        empty.addEventListener('dragenter', dragEnter);
        empty.addEventListener('dragleave', dragLeave);
        empty.addEventListener('drop', dragDrop);
      }
      const endTime = performance.now();
      console.log(`Executed in ${endTime - startTime}`);

      // Drag Functions

      function dragStart() {
        this.className += ' hold';
        setTimeout(() => (this.className = 'invisible'), 0);
      }

      function dragEnd() {
        this.className = 'fill';
      }

      function dragOver(e) {
        e.preventDefault();
      }

      function dragEnter(e) {
        e.preventDefault();
        this.className += ' hovered';
      }

      function dragLeave() {
        this.className = 'empty';
      }

      function dragDrop() {
        this.className = 'empty';
        this.append(fill);
      }
    </script>
  </body>
</html>
